# ag - tools for apigo.cc/gojs

## Install

```shell
go install apigo.cc/ag@latest
```

## Usage

```
tools for apigo.cc/gojs

Usage:
  ag [command] [...]
  ag [short command] [...]

Commands:
  init [i] [service|client]           init a new project for empty dir
  build [b] [all|os arch]             build project
  pack [p] [all|os arch]              pack project
  run [r] [args...]                   run project
  buildrun [rr] [args...]             build and run project
  watch [w] [args...]                 run and watch project
  buildwatch [ww] [args...]           build and run and watch project
  test [t] [args...]                  test project
  buildtest [tt] [args...]            build and test project
  tidy [td]                           tidy project, run go mod tidy
  check [ck]                          check go modules version
  export [e]                          export typescript code for dev
  tags []                             show git tags
  add tag [t+] [version]              add git tag and push, if no new tag specified will use last tag +1
  commit [c+] comment                 commit git repo and push, comment is need

Examples:
  ag init           init a new default project
  ag init service   init a new service project
  ag init client    init a new client project
  ag init all       init a new project use all modules by apigo.cc/ag/all included
  ag build          build project
  ag build all      build project for all platforms
  ag run            run project
  ag test           test project

```

