import s from 'apigo.cc/gojs/service'
import u from 'apigo.cc/gojs/util'
import Dao from './_Dao'

let _verifies = {}

let dao = {
    // --- {{- range . }}
    "--{{.table}}--": new Dao('{{.table}}', {
        pk: '{{.pk}}',
        listFields: '{{.listFields}}',
        searchFields: '{{.searchFields}}',
        getFields: '{{.getFields}}',
        updateFields: '{{.updateFields}}',
        ignoreFields: '{{.ignoreFields}}',
        ownerField: '{{.ownerField}}',
        versionField: '{{.versionField}}',
        validField: '{{.validField}}',
        addUserField: '{{.addUserField}}',
        addTimeField: '{{.addTimeField}}',
        updateUserField: '{{.updateUserField}}',
        updateTimeField: '{{.updateTimeField}}',
        makeID: "--{{.makeID}}--",
        ignore: "{{.ignore}}",
    }),
    // --- {{- end }}
    config: function ({ db, redis, userKey, verifies }) {
        Dao.config({ db, redis, userKey })
        if (verifies) _verifies = verifies
    },
    adminRegisters: {
        // --- {{- range . }}
        "--{{.table}}--": { list: {}, get: {}, update: {}, remove: {} },
        // --- {{- end }}
    },
    registers: {
        // --- {{- range . }}
        // --- {{- if not .ignore }}
        "--{{.table}}--": { list: {}, get: {}, update: {}, remove: {} },
        // --- {{- end }}
        // --- {{- end }}
    },
    registerAdmin: function (authLevel) {
        for (let table in this.adminRegisters) {
            // 根据设置注册管理接口
            let set = this.adminRegisters[table]
            for (let action in set) {
                registerService(table, 'admin', action, set[action], authLevel || 9)
            }
        }
    },
    register: function (authLevel, writeAuthLevel) {
        for (let table in this.registers) {
            for (let action in this.registers[table]) {
                let set = this.registers[table][action]
                if (action === 'list' || action === 'get' || action === 'update' || action === 'remove' || set.method || set.path || set.authLevel || set.action) {
                    // 根据设置注册接口
                    registerService(table, '', action, set, authLevel || 1)
                } else {
                    // 注册一组接口
                    let scope = action
                    for (let action in set) {
                        registerService(table, scope, action, set[action], authLevel || 1)
                    }
                }
            }
        }
    },
}

function registerService(table, scope, actionName, set, authLevel) {
    let prefix = scope ? `/${scope}/${table}/` : `/${table}/`
    let isAdmin = scope === 'admin'
    let fromAPI = true
    let action = set.action
    set = u.getByKey(set, ['authLevel', 'host', 'method', 'path', 'memo', 'noBody', 'noLog200', 'limiters', 'verifies', 'requires', 'onMessage', 'onClose'])
    if (!set.path) set.path = prefix + actionName
    // let isRead = actionName.startsWith('list') || actionName.startsWith('get')
    if (!set.method) set.method = 'POST'
    if (!set.authLevel) set.authLevel = authLevel || 0
    if (!set.verifies) set.verifies = _verifies
    if (!action && dao[table][actionName]) action = ({ args, session }) => { return { code: 1, message: '', data: dao[table][actionName]({ args, session, isAdmin, fromAPI }) } }
    if (action) s.register(set, action)
}

export default dao
