import dao from '../dao'

// 按需复制代码到接口服务中使用

// 定制接口示例
// dao.registers.XXXX.list = { method: 'POST', path: '/XXXX/list', authLevel: 1, action: ({ args, session }) => { return { code: 1, message: '', data: dao.XXXX.list({ args, session }) } } }
// dao.registers.XXXX.admin.list = { method: 'POST', path: '/XXXX/list', authLevel: 1, action: ({ args, session }) => { return { code: 1, message: '', data: dao.XXXX.list({ args, session, isAdmin: true }) } } }

// 默认注册配置
// --- {{- range . }}
// --- {{- if not .ignore }}
dao.registers."--{{.table}}--" = { list: {}, get: {}, update: {}, remove: {} }
// --- {{- end }}
// --- {{- end }}

// 管理接口注册配置
// --- {{- range . }}
dao.adminRegisters."--{{.table}}--" = { list: {}, get: {}, update: {}, remove: {} }
// --- {{- end }}

// 默认字段配置（根据实际需要调整字段配置，默认使用全部字段）
// --- {{- range . }}
dao."--{{.table}}--".listFields = '{{.listFields}}'.split(', ')
dao."--{{.table}}--".searchFields = '{{.searchFields}}'.split(', ')
dao."--{{.table}}--".getFields = '{{.getFields}}'.split(', ')
dao."--{{.table}}--".updateFields = '{{.updateFields}}'.split(', ')
dao."--{{.table}}--".ignoreFields = '{{.ignoreFields}}'.split(', ')
// --- {{- end }}

// 在API服务代码中调用进行默认接口注册，管理接口（使用authLevel:9进行身份验证），业务接口（使用authLevel:1进行身份验证，使用authLevel:2进行写操作身份验证））
dao.registerAdmin(9)
dao.register(1, 2)
